import * as types from "../actionTypes";
import axios from "axios";

const url = "http://subdomain.entony.fs.a-level.com.ua/api/auth/";
const userUrl = "http://subdomain.entony.fs.a-level.com.ua/api/users/";

const authRequest = () => ({
	type: types.AUTH_REQUEST
});

const authRequestSuccess = payload => ({
	type: types.AUTH_REQUEST_SUCCESS,
	payload
});

const authRequestFail = payload => ({
	type: types.AUTH_REQUEST_FAIL,
	payload
});

export const auth = payload => {
	return dispatch => {
		dispatch(authRequest());

		axios({
			method: "POST",
			url: url + "login",
			data: payload
		})
			.then(({ data }) => {
				localStorage.setItem("token", data.token);
				dispatch(authRequestSuccess(data.user));
			})
			.catch(err => dispatch(authRequestFail(err)));
	};
};

const registrationRequest = () => ({
	type: types.REGISTRATION_REQUEST
});

const registrationSuccess = payload => ({
	type: types.REGISTRATION_REQUEST_SUCCESS,
	payload
});

const registrationFail = payload => ({
	type: types.REGISTRATION_REQUEST_FAIL,
	payload
});

export const registration = payload => {
	return dispatch => {
		dispatch(registrationRequest());

		axios({
			method: "POST",
			url: `${url}register`,
			data: payload
		})
			.then(res => dispatch(registrationSuccess(res)))
			.catch(err => dispatch(registrationFail(err)));
	};
};

const getUserById = () => ({
	type: types.GET_USER_BY_ID
});

const getUserByIdSuccess = payload => ({
	type: types.GET_USER_BY_ID_SUCCESS,
	payload
});

const getUserByIdFail = payload => ({
	type: types.GET_USER_BY_ID_FAIL,
	payload
});

export const getUserByIdRequest = payload => {
	return dispatch => {
		dispatch(getUserById());

		axios({
			method: "GET",
			url: userUrl + payload.id,
			headers: {
				Authorization: `Bearer ${payload.token}`
			}
		})
			.then(({ data }) => dispatch(getUserByIdSuccess(data)))
			.catch(err => dispatch(getUserByIdFail(err)));
	};
};
