import * as types from "../actionTypes";
import axios from "axios";
import rmFFromObject from "../utils/rmPropFromObject";

export const addItem = () => {
	return {
		type: types.ADD_TO_LIST
	};
};

export const getAlllist = payload => ({
	type: types.GET_ALL_LIST,
	payload
});

export const updateName = payload => ({
	type: types.UPDATE_ITEM_NAME,
	payload
});

export const removeItem = payload => ({
	type: types.REMOVE_ITEM,
	payload
});

export const setItemToUpdate = payload => ({
	type: types.SET_ITEM_TO_UPDATE,
	payload
});

export const changeInputValue = payload => ({
	type: types.CHANGE_INPUT_VALUE,
	payload
});

const postRequest = payload => ({
	type: types.POST_REQUEST,
	payload
});

const postRequestSuccess = payload => ({
	type: types.POST_REQUEST_SUCCESS,
	payload
});

const postRequestFail = payload => ({
	type: types.POST_REQUEST_FAIL,
	payload
});

export const post = payload => async dispatch => {
	try {
		dispatch(postRequest());
		const data = await axios({
			method: "POST",
			url: "https://test-request-4b9d7.firebaseio.com/post.json",
			data: payload
		});

		dispatch(postRequestSuccess(data));
	} catch (error) {
		dispatch(postRequestFail(error));
	}
};

const getAllPostRequest = payload => ({
	type: types.GET_ALL_POST_REQUEST,
	payload
});

const getAllPostRequestSuccess = payload => ({
	type: types.GET_ALL_POST_REQUEST_SUCCESS,
	payload
});

const getAllPostRequestFail = payload => ({
	type: types.GET_ALL_POST_REQUEST_FAIL,
	payload
});

export const getAllposts = () => async dispatch => {
	try {
		dispatch(getAllPostRequest());
		const data = await axios({
			method: "GET",
			url: "https://test-request-4b9d7.firebaseio.com/post.json"
		});

		dispatch(getAllPostRequestSuccess(data));
	} catch (error) {
		dispatch(getAllPostRequestFail(error));
	}
};

const removeRequest = payload => ({
	type: types.REMOVE_REQUEST,
	payload
});

const removeRequestSuccess = payload => ({
	type: types.REMOVE_REQUEST_SUCCESS,
	payload
});

const removeRequestFail = payload => ({
	type: types.REMOVE_REQUEST_FAIL,
	payload
});

export const remove = payload => async dispatch => {
	try {
		dispatch(removeRequest(payload));
		const data = await axios({
			method: "DELETE",
			url: `https://test-request-4b9d7.firebaseio.com/post/${payload}.json`
		});

		dispatch(removeRequestSuccess(data));
	} catch (error) {
		dispatch(removeRequestFail(error));
	}
};

const updateRequest = payload => ({
	type: types.UPDATE_REQUEST,
	payload
});

const updateRequestSuccess = payload => ({
	type: types.UPDATE_REQUEST_SUCCESS,
	payload
});

const updateRequestFail = payload => ({
	type: types.UPDATE_REQUEST_FAIL,
	payload
});

export const update = payload => async dispatch => {
	try {
		const { id, ...rest } = payload;
		// const data2 = rmFFromObject(payload, 'id')
		dispatch(updateRequest());
		const data = await axios({
			method: "PUT",
			url: `https://test-request-4b9d7.firebaseio.com/post/${id}.json`,
			data: rest
		});

		dispatch(updateRequestSuccess(data));
	} catch (error) {
		dispatch(updateRequestFail(error));
	}
};

export const setInitialValue = payload => ({
	type: types.SET_INITIAL_VALUES,
	payload
});
