import React from "react";

import "./index.scss";

export const Input = ({ label, type = "text", touch, valid, ...rest }) => {
	return (
		<div className="input">
			<label htmlFor="" className="input__label">
				<span className="input__label--span">{label}</span>
				<input
					className={touch && valid ? "input__input input__input--error" : "input__input"}
					type={type}
					{...rest}
				/>
			</label>
		</div>
	);
};

export const InputConstructor = ({ inputType, label, touch, valid, ...rest }) => {
	switch (inputType) {
		case "checkbox": {
			return (
				<>
					{label && (
						<label className="input__label">
							<span className="input__label--span">{label}</span>
						</label>
					)}
					<input
						className={touch && valid ? "input__input input__input--error" : "input__input"}
						type="checkbox"
						{...rest}
					/>
				</>
			);
		}

		default: {
			return (
				<>
					{label && (
						<label className="input__label">
							<span className="input__label--span">{label}</span>
						</label>
					)}
					<input className={touch && valid ? "input__input input__input--error" : "input__input"} {...rest} />
				</>
			);
		}
	}
};
