import React from "react";
import Header from "../header";
import Footer from "../footer";

class Layout extends React.Component {
	// static getDerivedStateFromProps(nextProps, prevState) {
	// 	console.log("getDerivedStateFromProps", document.getElementById("container"));
	// 	console.log("nextProps", nextProps);
	// 	console.log("prevState", prevState);
	// 	return null;
	// }

	constructor(props) {
		super(props);
		// console.log("props", props);

		this.state = { randomNumber: 0, user: {} };
	}

	// UNSAFE_componentWillMount() {
	// 	console.log("UNSAFE_componentWillMount", document.getElementById("container"));
	// }

	async componentDidMount() {
		console.log("componentDidMount", this.state);
		fetch("https://jsonplaceholder.typicode.com/todos/1")
			.then(response => response.json())
			.then(json => this.setState({ user: json }));
		this.setState({ randomNumber: Math.floor(Math.random() * 100 + 1) });
	}

	// shouldComponentUpdate(nextProps, nextState, nextContext) {
	// 	console.log("shouldComponentUpdate nextProps", nextProps);
	// 	console.log("shouldComponentUpdate this.state", this.state);
	// 	console.log("shouldComponentUpdate nextState", nextState);
	// 	console.log("shouldComponentUpdate nextContext", nextContext);

	// 	return true;
	// }

	// getSnapshotBeforeUpdate(prevProps, prevState) {
	// 	console.log("getSnapshotBeforeUpdate prevProps", prevProps);
	// 	console.log("getSnapshotBeforeUpdate prevState", prevState);
	// 	return null;
	// }

	// componentDidUpdate(prevProps, prevState, snapshot) {
	// 	console.log("componentDidUpdate prevProps", prevProps);
	// 	console.log("componentDidUpdate prevState", prevState);
	// 	console.log("componentDidUpdate snapshot", snapshot);
	// }

	// componentWillUpdate() {
	// 	console.log("componentWillUpdate");
	// }

	static defaultProps = {
		header: true,
		footer: true
	};

	render() {
		const { children, header, footer, wrapperClassName } = this.props;
		const { randomNumber } = this.state;

		// console.log("render");
		return (
			<div className="container" id="container">
				{header && <Header randomNumber={randomNumber} />}
				<div className={wrapperClassName}>{children}</div>

				{footer && <Footer />}
			</div>
		);
	}
}

export default Layout;
