import React, { Component } from "react";
import { Link } from "react-router-dom";

const tabs = [
	{ id: 1, path: "?tab=1", title: "Tab 1" },
	{ id: 2, path: "?tab=2", title: "Tab 2" },
	{ id: 3, path: "?tab=3", title: "Tab 3" },
	{ id: 4, path: "?tab=4", title: "Tab 4" }
];

export default class AboutUs extends Component {
	state = { currentTab: 1 };

	inputRef = React.createRef();

	componentDidMount() {
		const params = new URLSearchParams(this.props.location.search);
		const tab = params.get("tab");
		if (tab) {
			this.setState({ currentTab: tab });
		} else {
			this.setState({ currentTab: 1 });
		}
	}

	componentDidUpdate(prevProps, prevState) {
		const params = new URLSearchParams(this.props.location.search);
		const tab = params.get("tab");

		if (prevState.currentTab !== tab) {
			this.setState({ currentTab: tab });
		}
	}

	renderTab = tab => {
		let div = null;
		switch (tab) {
			case "1": {
				div = <div>CAse 1</div>;
				break;
			}
			case "2": {
				div = <div>CAse 2</div>;
				break;
			}
			case "3": {
				div = <div>CAse 3</div>;
				break;
			}
			case "4": {
				div = <div>CAse 4</div>;
				break;
			}

			default: {
				div = null;
			}
		}

		return div;
	};

	render() {
		const { location } = this.props;
		console.log("this", this);
		return (
			<>
				<div>
					<h1
						ref={root => {
							this.ololo = root;
						}}>
						About ua page
					</h1>

					<div className="tabs" ref={this.inputRef}>
						{tabs.map(el => (
							<div
								key={el.id}
								className={location.search === el.path ? "tabs__item tabs__item--active" : "tabs__item"}>
								<Link className="tabs__link" to={`${location.pathname}${el.path}`}>
									{el.title}
								</Link>
							</div>
						))}
					</div>

					<div className="tabs__content" ref={this.inputRef}>
						{this.renderTab(this.state.currentTab)}
					</div>
				</div>
			</>
		);
	}
}
