import React, { useState, useEffect } from "react";

export const Hooks = () => {
	const [count, setCount] = useState(100);
	const [value, setValue] = useState("");

	useEffect(() => {
		document.title = Math.random()
			.toString()
			.substr(5);

		document.addEventListener("click", clickEvent);

		return () => {
			document.removeEventListener("click", clickEvent);
		};
	}, []);

	useEffect(() => {
		setValue(count);
	}, [count]);

	const clickEvent = e => {
		console.log("e", e);
	};

	return (
		<div>
			<div>
				<h1>{count}</h1>
				<button onClick={() => setCount(count + 1)}>INC</button>
				<button onClick={() => setCount(prevState => prevState - 1)}>DEC</button>
			</div>

			<div>
				<input type="text" value={value} onChange={e => setValue(e.target.value)} />
			</div>
		</div>
	);
};
