import React, { Component } from "react";
import axios from "axios";
import { Link, Switch, Route } from "react-router-dom";

import Menu from "../components/menu";
import HOCcomponent from "../components/HOC/resize";

const One = () => {
	return (
		<div>
			<h1>ONe component</h1>
		</div>
	);
};

const Two = () => (
	<div>
		<h1>Two component</h1>
	</div>
);

class Main extends Component {
	state = {
		posts: [],
		post: {},
		loading: false,
		value: "Hello",
		optionValue: "0",
		option: ""
	};

	async componentDidMount() {
		const params = new URLSearchParams(this.props.location.search);

		params.forEach(el => console.log("el", el));
		console.log("params/", params.get("name"));

		const request = await fetch("https://jsonplaceholder.typicode.com/posts");
		const json = await request.json();

		this.setState({ posts: json });
	}

	startLoading = () => this.setState({ loading: true });

	getOnePost = async id => {
		const post = await axios({
			url: "https://jsonplaceholder.typicode.com/posts/" + id,
			method: "GET"
		});

		this.setState({ post: post.data, loading: false });
	};

	inputChange = e => this.setState({ value: e.target.value });
	selectChange = e => this.setState({ optionValue: e.target.value });

	submit = e => {
		e.preventDefault();

		console.log("input", this.state.value);
		console.log("select", this.state.optionValue);
	};

	handleRadioChange = e => {
		this.setState({ option: e.target.value });
	};

	render() {
		const { posts, post, loading } = this.state;

		console.log("this", this.props);

		return (
			<>
				<Menu posts={posts} getOnePost={this.getOnePost} startLoading={this.startLoading} />
				{!loading ? (
					<div>{Object.keys(post).length === 0 ? <div>Choose some tipic</div> : <div>{post.body}</div>}</div>
				) : (
					<div>Loading...</div>
				)}

				<form onSubmit={this.submit}>
					<input type="text" value={this.state.value} onChange={this.inputChange} />
					<select value={this.state.optionValue} onChange={this.selectChange}>
						<option value="0">Язык HTML</option>
						<option value="1">Язык CSS</option>
						<option value="2">Язык JavaScript</option>
						<option value="3">Язык PHP</option>
					</select>
					<button type="submit">Submit</button>

					<p>Ваш выбор: {this.state.option}</p>

					<input
						name="lang"
						type="radio"
						value="option1"
						// checked={this.state.option === "option1"}
						onChange={this.handleRadioChange}
					/>

					<input
						name="lang"
						type="radio"
						value="option2"
						// checked={this.state.option === "option2"}
						onChange={this.handleRadioChange}
					/>
				</form>

				<div>
					<ul>
						<li>
							<Link to="/one">One</Link>
						</li>
						<li>
							<Link to="/two">Two</Link>
						</li>
					</ul>

					<Switch>
						<Route exact path="/one" component={One} />
						<Route exact path="/two" component={Two} />
					</Switch>
					<h1>OUTSIDE CONTAINER</h1>
				</div>
			</>
		);
	}
}
// export default Main;
export default HOCcomponent(Main);
