import React, { Component } from "react";
import { connect } from "react-redux";
import { changeInputValue, post, getAllposts, remove, setInitialValue, update } from "../actions/todo";

import { InputConstructor } from "../components/input";

class ThunkTodo extends Component {
	componentDidMount() {
		this.props.getAllposts();
	}

	onChangeHandler = e => {
		const { value, name, checked, type } = e.target;
		this.props.changeInputValue({ value, name, checked, type });
	};

	postData = () => {
		this.props.post(this.props.formValue);
	};

	updateData = () => {
		this.props.update(this.props.formValue);
	};

	render() {
		const { fistName, lastName, age, editable } = this.props.formValue;
		console.log("thisp", this.props.updateId);
		return (
			<div className="todo-t">
				<div className="todo-t__form">
					<div className="todo-t__item">
						<InputConstructor
							name="fistName"
							onChange={this.onChangeHandler}
							label="FirstName"
							value={fistName}
						/>
					</div>
					<div className="todo-t__item">
						<InputConstructor
							name="lastName"
							onChange={this.onChangeHandler}
							label="LastName"
							value={lastName}
						/>
					</div>
					<div className="todo-t__item">
						<InputConstructor name="age" onChange={this.onChangeHandler} label="Age of person" value={age} />
					</div>
					<div className="todo-t__item">
						<InputConstructor
							name="editable"
							onChange={this.onChangeHandler}
							label="Editable"
							inputType="checkbox"
							checked={editable}
						/>
					</div>
					<div className="todo-t__btn">
						{this.props.updateId ? (
							<button onClick={this.updateData}>PUT DATA</button>
						) : (
							<button onClick={this.postData}>POST DATA</button>
						)}
					</div>
				</div>

				<div className="todo-t__list">
					{this.props.remoteList.map(el => (
						<div key={el.id}>
							<h4>{`${el.fistName} ${el.lastName}`}</h4>
							<p>{el.age} ears old</p>

							<button onClick={this.props.remove.bind(null, el.id)}>x</button>
							<button onClick={this.props.setInitialValue.bind(null, el.id)}>edit</button>
						</div>
					))}
				</div>
			</div>
		);
	}
}

const mapStateToProps = state => {
	return {
		formValue: state.todo.remoteTodo,
		remoteList: state.todo.remoteList,
		updateId: state.todo.updateId
	};
};

export default connect(
	mapStateToProps,
	{ changeInputValue, post, getAllposts, remove, setInitialValue, update }
)(ThunkTodo);
