import React, { Component } from "react";
import axios from "axios";

const getData = () =>
	new Promise(resolve => {
		setTimeout(() => {
			const localQoute = localStorage.getItem("quote");
			resolve(JSON.parse(localQoute));
		}, 2000);
	});

export default class Todo extends Component {
	state = { quote: "", qouteFromLocalStorage: "" };
	inputRef = React.createRef();

	async componentDidMount() {
		const data = await getData();

		this.setState({ qouteFromLocalStorage: data });
		console.log("data l", data);
	}

	componentDidUpdate(prevProps, prevState) {
		if (!prevState.quote && this.state.quote) {
			this.inputRef.current.focus();
		}
	}

	uploadQ = async () => {
		try {
			const { data } = await axios.get("https://api.kanye.rest");

			this.setState({ quote: data.quote });
			console.log("data", data);
			// this.inputRef.current.focus();
		} catch (error) {
			console.warn("error", error);
		}
	};

	quoteChangeEvent = e => {
		const { value } = e.target;

		this.setState({ quote: value });
	};

	saveQuote = () => {
		const newItem = {
			id: Math.random()
				.toString()
				.substr(2, 9),
			quote: this.state.quote
		};
		const localQoute = localStorage.getItem("quote");

		if (!localQoute) {
			localStorage.setItem("quote", JSON.stringify([].concat(newItem)));
		} else {
			const q = JSON.parse(localQoute);
			localStorage.setItem("quote", JSON.stringify(q.concat(newItem)));
		}

		this.setState({ quote: "" });
	};

	render() {
		const { quote, qouteFromLocalStorage } = this.state;

		return (
			<div className="todo">
				<button className="uploadButton" onClick={this.uploadQ}>
					Upload
				</button>

				{/* <div>{this.state.quote}</div> */}

				{quote ? (
					<>
						<div className="wrapper">
							<label>
								<input
									className="input"
									ref={this.inputRef}
									value={quote}
									onChange={this.quoteChangeEvent}
									type="text"
								/>
							</label>
							<button onClick={this.saveQuote}>Save</button>
						</div>
					</>
				) : (
					<div className="empty">Click to get quote</div>
				)}
				<hr />
				<pre className="pre">{JSON.stringify(qouteFromLocalStorage, null, 2)}</pre>
			</div>
		);
	}
}
