import React, { Component } from "react";
// import { bindActionCreators } from "redux";
import { connect } from "react-redux";
// import { updateName } from "../actions/todo";
import * as actions from "../actions/todo";

const fakeData = () => {
	return new Promise(resolve => {
		setTimeout(() => {
			const items = [
				{
					name: "John",
					id: "1"
				},
				{
					name: "Tony",
					id: "2"
				}
			];

			resolve(items);
		}, 2000);
	});
};

export class TodoRedux extends Component {
	async componentDidMount() {
		const data = await fakeData();
		console.log("data", data);

		this.props.getAlllist(data);
	}

	render() {
		const { name, updateName, addItem, list, removeItem, editMode, setItemToUpdate } = this.props;
		console.log("this.props", this.props);
		return (
			<div>
				<div>
					<input type="text" name="name" value={name} onChange={e => updateName(e.target.value)} />
					<button onClick={addItem}>{editMode ? "UPDATE" : "SAVE"}</button>
				</div>

				<ul>
					{list.map(el => (
						<li key={el.id}>
							{el.name} <button onClick={setItemToUpdate.bind(null, el.id)}>EDIT</button>{" "}
							<button onClick={removeItem.bind(null, el.id)}>DEL</button>
						</li>
					))}
				</ul>
			</div>
		);
	}
}

const mapStateToProps = state => {
	console.log("state", state);
	return {
		list: state.todo.list,
		name: state.todo.item.name,
		editMode: state.todo.editMode
	};
};

// const mapDispatchToProps = dispatch => {
// 	return {
// 		updateName: payload => dispatch(updateName(payload))
// 	};
// };

// const mapDispatchToProps = dispatch => bindActionCreators({ updateName }, dispatch);

export default connect(
	mapStateToProps,
	actions
)(TodoRedux);
