import React from "react";

import { Route, Redirect } from "react-router-dom";
import { decodeJWT } from "./utils/checkJWTToken";

import Layout from "./components/layout";

export const PrivateRouter = ({ component: Component, protectedRoute, hasAccess, ...rest }) => (
	<Route
		{...rest}
		render={props => {
			if (protectedRoute) {
				const token = localStorage.getItem("token");
				if (!token) return <Redirect to="/auth" />;

				const { role } = decodeJWT(token);
				const has = hasAccess.some(el => el === role);
				if (!has) return <Redirect to="/auth" />;

				return (
					<Layout footer={false} wrapperClassName="main">
						<Component {...props} />
					</Layout>
				);
			}
			return (
				<Layout footer={false} wrapperClassName="main">
					<Component {...props} />
				</Layout>
			);
		}}
	/>
);
