import * as types from "../actionTypes";

const initialState = {
	user: null,
	isFetching: false
};

export default (state = initialState, { type, payload }) => {
	switch (type) {
		case types.GET_USER_BY_ID:
		case types.REGISTRATION_REQUEST:
		case types.AUTH_REQUEST: {
			return { ...state, isFetching: true };
		}

		case types.AUTH_REQUEST_SUCCESS: {
			return { ...state, isFetching: false, user: payload };
		}

		case types.GET_USER_BY_ID_FAIL:
		case types.REGISTRATION_REQUEST_FAIL:
		case types.AUTH_REQUEST_FAIL: {
			return { ...state, isFetching: false };
		}

		case types.REGISTRATION_REQUEST_SUCCESS: {
			return { ...state, isFetching: false };
		}
		case types.GET_USER_BY_ID_SUCCESS: {
			const { user } = payload;
			return { ...state, isFetching: false, user };
		}

		default: {
			return state;
		}
	}
};
