import React from "react";

import { setCssVariables } from "./setSCCvariables";
import { GLOBAL_DEFAULT_THEME } from "../contants";

const en = require("../i18n/en.json");
const ru = require("../i18n/ru.json");
const ua = require("../i18n/ua.json");

export const languages = [
	{
		name: "en",
		title: "En",
		json: en
	},
	{
		name: "ru",
		title: "Ru",
		json: ru
	},
	{
		name: "ua",
		title: "Ua",
		json: ua
	}
];

export const setLanguage = lang => {
	const language = languages.find(el => el.name === lang);

	return language ? language.json : en;
};

export const LocalContext = React.createContext({
	json: setLanguage(navigator.language),
	setLanguage,
	setCssVariables,
	lang: navigator.language,
	theme: GLOBAL_DEFAULT_THEME
});
